/* eslint-disable react/no-unstable-nested-components */
import {
    ActionEnum,
    ActionPopup,
    ActionState,
    Form,
    FormFieldWrapper,
    Popup,
    PopupContent,
    PopupHeader,
} from '@ensi-platform/core-components';
import { Row, createColumnHelper } from '@tanstack/react-table';
import { useRouter } from 'next/router';
import { useCallback, useEffect, useMemo, useState } from 'react';
import * as Yup from 'yup';

import { Property, useCategoryBindProperties, useCategoryDetail, useCategoryPropertiesMeta } from '@api/catalog';

import { useError, useModalsContext, useSuccess } from '@context/modal';

import { initialSort } from '@views/logistic/pickup-points/[id]/scripts/constants';

import LoadWrapper from '@controls/LoadWrapper';
import Select from '@controls/Select';
import Tooltip, { ContentBtn, hideOnEsc } from '@controls/Tooltip';

import Table, { ExtendedRow, TooltipItem, useSorting, useTable } from '@components/Table';
import { getSelectColumn, getSettingsColumn } from '@components/Table/columns';
import { Cell, TableEmpty, TableHeader } from '@components/Table/components';

import { CREATE_PARAM, ErrorMessages, ModalMessages } from '@scripts/constants';
import { ActionType } from '@scripts/enums';
import { Button, scale, typography } from '@scripts/gds';
import { declOfNum } from '@scripts/helpers';
import { usePopupState } from '@scripts/hooks';
import { useAutoColumns, useAutoFilters, useAutoTableData } from '@scripts/hooks/autoTable';

import KebabIcon from '@icons/small/kebab.svg';
import TipIcon from '@icons/small/status/tip.svg';

const booleanOptions = [
    { key: 'Не выбрано', value: '' },
    { key: 'Нет', value: '0' },
    { key: 'Да', value: '1' },
];

const invalidGluingTypes = ['Файл', 'Текст'];
const isValidGluingType = (row: ExtendedRow['original']) => !invalidGluingTypes.includes(row.original.type);

interface ISelfPropertiesTableProps {
    canEditCategoryData: boolean;
}

interface IChangeRequiredAttributesForm {
    is_required: boolean | string;
}

interface IChangeGluingForm {
    is_gluing: boolean | string;
}

export default function SelfPropertiesTable({ canEditCategoryData }: ISelfPropertiesTableProps) {
    const { query } = useRouter();
    const { appendModal } = useModalsContext();
    const id = Array.isArray(query.pid) ? query.pid[0] : query.pid;
    const isCreatePage = id === CREATE_PARAM;

    const [deletePopupState, deletePopupDispatch] = usePopupState<Partial<ActionState>>({
        open: false,
    });
    const [isEditOpen, setIsEditOpen] = useState(false);
    const [isEditGluingOpen, setIsEditGluingOpen] = useState(false);
    const [selectedIds, setSelectedIds] = useState<number[]>([]);

    const [tippyInstance, setTippyInstance] = useState<any>();

    useEffect(() => {
        if (deletePopupState.open || isEditOpen || isEditGluingOpen) tippyInstance?.hide();
    }, [tippyInstance, deletePopupState, isEditOpen, isEditGluingOpen]);

    const { data: category } = useCategoryDetail(Number(id), !!id && !isCreatePage);
    const categoryData = useMemo(() => category?.data, [category]);

    const { data: meta } = useCategoryPropertiesMeta();
    const metaData = useMemo(() => meta?.data, [meta]);

    const { metaField } = useAutoFilters(metaData);

    const [{ sorting }, sortingPlugin] = useSorting<Property>(
        'products-categories-properties',
        metaData?.fields,
        initialSort,
        false
    );

    const propertiesComputedList = useMemo(
        () =>
            [
                ...(categoryData?.properties?.filter(item => !item.is_inherited) || []),
                ...(categoryData?.hidden_properties?.filter(item => !item.is_inherited) || []),
            ]?.map(item => ({
                ...item,
                id: item?.property_id,
                customListLink: '/products/directories/properties',
            })),
        [categoryData]
    );

    const propertiesTableData = useAutoTableData<Property>(propertiesComputedList, metaField);

    // eslint-disable-next-line react-hooks/exhaustive-deps
    const tableData = useMemo(() => propertiesTableData, [propertiesComputedList, metaField]);

    const autoGeneratedColumns = useAutoColumns(metaData);

    const bindProperties = useCategoryBindProperties();

    useError(bindProperties?.error);
    useSuccess(bindProperties?.isSuccess ? ModalMessages.SUCCESS_UPDATE : '');

    const tooltipContent: TooltipItem[] = useMemo(
        () => [
            {
                type: 'delete',
                text: 'Удалить атрибуты',
                action: (originalRows: ExtendedRow['original'][] | undefined) => {
                    if (!originalRows) return;
                    deletePopupDispatch({ type: ActionType.Delete });
                    setSelectedIds(originalRows.map(r => Number(r?.original?.property_id)));
                },
                isDisable: !canEditCategoryData,
            },
            {
                type: 'edit',
                text: 'Изменить обязательность атрибутов',
                action: (originalRows: ExtendedRow['original'][] | undefined) => {
                    if (!originalRows) return;
                    setIsEditOpen(true);
                    setSelectedIds(originalRows.map(r => Number(r?.original.property_id)));
                },
                isDisable: !canEditCategoryData,
            },
            {
                type: 'edit',
                text: 'Изменить параметр склеивания атрибутов',
                action: (originalRows: ExtendedRow['original'][] | undefined) => {
                    if (!originalRows) return;
                    setIsEditGluingOpen(true);
                    setSelectedIds(originalRows.map(r => Number(r?.original.property_id)));
                },
                isDisable: (originalRow: ExtendedRow['original'][] | undefined) => {
                    if (!originalRow) return;
                    return !(originalRow.every(row => isValidGluingType(row)) && canEditCategoryData);
                },
                ...(canEditCategoryData && { disabledHint: 'Склеивание атрибутов типа Файл и Текст запрещено' }),
            },
        ],
        [canEditCategoryData]
    );

    const columnHelper = createColumnHelper<Property>();
    const columns = useMemo(
        () => [
            getSelectColumn(0, 'SelfPropertiesTable'),
            ...(autoGeneratedColumns &&
                autoGeneratedColumns.filter(
                    item =>
                        item?.accessorKey &&
                        !['created_at', 'updated_at', 'is_required'].includes(String(item?.accessorKey))
                )),
            columnHelper.accessor('is_required', {
                header: 'Обязательный',
                cell: ({ getValue }) => <Cell value={getValue()} type="bool" />,
            }),
            getSettingsColumn({ columnsToDisable: [], visibleColumns: metaData?.default_list, tooltipContent }),
        ],
        [autoGeneratedColumns, metaData?.default_list]
    );

    const table = useTable(
        {
            data: tableData,
            columns,
            meta: {
                tableKey: 'products-categories-properties',
            },
            state: { sorting },
        },
        [sortingPlugin]
    );

    const deleteProperties = useCallback(
        async (selectedIds: number[]) => {
            // так как "удаление" происходит проставлением replace:true
            // то когда все удаляем сразу передаем листинг из деталки
            if (propertiesComputedList?.length === selectedIds?.length) {
                await bindProperties.mutateAsync({
                    id: Number(id),
                    replace: true,
                    properties: [],
                });
            } else {
                // а когда выборочно то нужно отсеять "не выбранные"
                const bindings = propertiesComputedList?.filter((p: Property) => !selectedIds?.includes(p.property_id));

                await bindProperties.mutateAsync({
                    id: Number(id),
                    replace: true,
                    properties: bindings
                        ? bindings?.map(({ property_id, is_required, is_gluing }) => ({
                              id: property_id,
                              is_required,
                              is_gluing,
                          }))
                        : [],
                });
            }
            table.resetRowSelection();
        },
        [bindProperties, propertiesComputedList, id, table]
    );

    const renderContentBtn = useCallback(
        (t: TooltipItem) => {
            const isDisabled =
                typeof t?.isDisable === 'function' ? t.isDisable(table.getSelectedRowModel().flatRows) : t?.isDisable;

            return (
                <div
                    css={{
                        display: 'flex',
                        alignItems: 'center',
                        paddingRight: isDisabled ? scale(1) : 0,
                    }}
                >
                    <ContentBtn
                        key={t.text}
                        type={t.type}
                        onClick={e => {
                            e.stopPropagation();
                            t.action(table.getSelectedRowModel().flatRows);
                        }}
                        disabled={isDisabled}
                    >
                        {t.text}
                    </ContentBtn>

                    {isDisabled && t?.disabledHint && (
                        <Tooltip
                            content={t.disabledHint}
                            trigger="mouseenter"
                            theme="dark"
                            placement="right-end"
                            minWidth={scale(40)}
                        >
                            <div
                                css={{
                                    display: 'flex',
                                    alignItems: 'center',
                                }}
                            >
                                <TipIcon />
                            </div>
                        </Tooltip>
                    )}
                </div>
            );
        },
        [tooltipContent]
    );

    const renderHeader = useCallback(
        (selectedRows: Row<any>[], resetSelection: () => void) => (
            <TableHeader>
                <div
                    css={{
                        display: 'flex',
                        justifyContent: 'space-between',
                        width: '100%',
                        padding: `0 ${scale(3)}px`,
                    }}
                >
                    <p css={{ lineHeight: '32px', ...typography('bodySm') }}>
                        {`${propertiesComputedList?.length} ${declOfNum(Number(propertiesComputedList?.length), [
                            'атрибут',
                            'атрибута',
                            'атрибутов',
                        ])}`}
                    </p>
                    {selectedRows?.length ? (
                        <div>
                            <span css={{ marginRight: scale(2) }}>Выбрано: {selectedRows.length}</span>
                            <Button theme="fill" onClick={() => resetSelection()} css={{ marginRight: scale(2) }}>
                                Снять выделение
                            </Button>
                            <Tooltip
                                content={tooltipContent.map(t => renderContentBtn(t))}
                                plugins={[hideOnEsc]}
                                trigger="click"
                                arrow
                                theme="light"
                                placement="bottom"
                                disabled={tooltipContent.length === 0}
                                appendTo={() => document.body}
                                onCreate={inst => setTippyInstance(inst)}
                            >
                                <Button
                                    theme="outline"
                                    Icon={KebabIcon}
                                    css={{ marginLeft: scale(2), marginRight: scale(2) }}
                                    iconAfter
                                    disabled={!canEditCategoryData}
                                >
                                    Действия
                                </Button>
                            </Tooltip>
                        </div>
                    ) : null}
                </div>
            </TableHeader>
        ),
        [canEditCategoryData, propertiesComputedList?.length, tooltipContent]
    );

    return (
        <LoadWrapper isLoading={bindProperties.isPending}>
            {propertiesComputedList?.length > 0 ? (
                <>
                    {renderHeader(table.getSelectedRowModel().flatRows, table.reset)}
                    <Table instance={table} />
                </>
            ) : null}

            {propertiesComputedList?.length === 0 ? (
                <TableEmpty
                    filtersActive={false}
                    titleWithFilters="Атрибутов не найдено"
                    titleWithoutFilters="Атрибутов нет"
                />
            ) : null}

            <ActionPopup
                open={!!deletePopupState.open}
                leftAddonIconTheme="delete"
                action={ActionEnum.DELETE}
                onAction={async () => {
                    deletePopupDispatch({ type: ActionType.PreClose });
                    await deleteProperties(selectedIds);
                }}
                onClose={() => {
                    deletePopupDispatch({ type: ActionType.PreClose });
                    setSelectedIds([]);
                }}
                onUnmount={() => {
                    deletePopupDispatch({ type: ActionType.Close });
                }}
                title="Удалить атрибут(ы)?"
                blockButtons
            />

            <Popup open={isEditOpen} onClose={() => setIsEditOpen(false)} size="sm">
                <PopupHeader title="Изменить обязательность атрибута" />
                <PopupContent>
                    <Form<IChangeRequiredAttributesForm>
                        initialValues={{
                            is_required: '',
                        }}
                        onSubmit={async vals => {
                            setIsEditOpen(false);

                            await bindProperties.mutateAsync({
                                id: Number(id),
                                replace: false,
                                properties: selectedIds.map(propertyId => ({
                                    id: propertyId,
                                    is_required: Boolean(Number(vals?.is_required)),
                                    is_gluing: propertiesTableData.filter(
                                        property => property.property_id === propertyId
                                    )[0]?.is_gluing,
                                })),
                            });
                        }}
                        validationSchema={Yup.object().shape({
                            is_required: Yup.string().required(ErrorMessages.REQUIRED),
                        })}
                    >
                        <FormFieldWrapper
                            name="is_required"
                            label="Обязательность атрибута"
                            css={{ marginBottom: scale(2) }}
                        >
                            <Select options={booleanOptions} />
                        </FormFieldWrapper>
                        <Button type="submit">Сохранить</Button>
                    </Form>
                </PopupContent>
            </Popup>
            <Popup open={isEditGluingOpen} onClose={() => setIsEditGluingOpen(false)} size="sm">
                <PopupHeader title="Изменить параметр склеивания атрибута" />
                <PopupContent>
                    <Form<IChangeGluingForm>
                        initialValues={{
                            is_gluing: '',
                        }}
                        onSubmit={async vals => {
                            const unavailableAttrs = tableData.filter(
                                ({ property_id, type }) =>
                                    selectedIds.includes(property_id) && (type === 'Файл' || type === 'Текст')
                            );
                            const unavailableIds = unavailableAttrs.map(a => a.id);
                            const postSelectedIds = selectedIds.filter(
                                selectedId => !unavailableIds.includes(selectedId)
                            );

                            setIsEditGluingOpen(false);

                            if (unavailableIds.length) {
                                appendModal({
                                    message: `Невозможно поменять параметр склейки у следующих атрибутов (ID): ${unavailableIds.map(
                                        i => i
                                    )}`,
                                    theme: 'error',
                                });
                            }
                            if (postSelectedIds.length) {
                                await bindProperties.mutateAsync({
                                    id: Number(id),
                                    replace: false,
                                    properties: postSelectedIds.map(propertyId => ({
                                        id: propertyId,
                                        is_required: propertiesTableData.filter(
                                            property => property.property_id === propertyId
                                        )[0]?.is_required,
                                        is_gluing: Boolean(Number(vals?.is_gluing)),
                                    })),
                                });
                            }
                        }}
                        validationSchema={Yup.object().shape({
                            is_gluing: Yup.string().required(ErrorMessages.REQUIRED),
                        })}
                    >
                        <FormFieldWrapper
                            name="is_gluing"
                            label="Параметр склеивания атрибута"
                            css={{ marginBottom: scale(2) }}
                        >
                            <Select options={booleanOptions} />
                        </FormFieldWrapper>
                        <Button type="submit">Сохранить</Button>
                    </Form>
                </PopupContent>
            </Popup>
        </LoadWrapper>
    );
}
